# The software in this package is distributed under the GNU General
# Public License version 2 (with a special exception described below).
#
# A copy of GNU General Public License (GPL) is included in this distribution,
# in the file COPYING.GPL.
#
# As a special exception, if other files instantiate templates or use macros
# or inline functions from this file, or you compile this file and link it
# with other works to produce a work based on this file, this file
# does not by itself cause the resulting work to be covered
# by the GNU General Public License.
#
# However the source code for this file must still be made available
# in accordance with section (3) of the GNU General Public License.
#
# This exception does not invalidate any other reasons why a work based
# on this file might be covered by the GNU General Public License.

""" Helper functions with iterators -- functional program is great!

Currently, recipes from python itertools docu (:py:mod:`itertools`) that have
been deemed useful

.. codeauthor:: Intra2net
"""

import itertools as it
from type_helpers import PY2, PY3


zip_longest = None
izip_longest = None
if PY2:
    zip_longest = it.izip_longest
    izip_longest = it.izip_longest
else:
    zip_longest = it.zip_longest
    izip_longest = it.zip_longest


def pairwise(iterable):
    """ s -> (s0,s1), (s1,s2), (s2, s3), ...  """
    a, b = it.tee(iterable)
    next(b, None)
    return zip(a, b)
